package com.lukouguoji.gjc.activity

import android.content.Context
import android.content.Intent
import android.os.Bundle
import com.alibaba.android.arouter.facade.annotation.Route
import com.lukouguoji.gjc.R
import com.lukouguoji.gjc.databinding.ActivityGjcQueryBinding
import com.lukouguoji.gjc.viewModel.GjcQueryViewModel
import com.lukouguoji.module_base.base.BaseBindingActivity
import com.lukouguoji.module_base.common.ConstantEvent
import com.lukouguoji.module_base.impl.FlowBus
import com.lukouguoji.module_base.impl.observe
import com.lukouguoji.module_base.ktx.getLifecycleOwner
import com.lukouguoji.module_base.router.ARouterConstants

/**
 * 国际出港查询列表页
 */
@Route(path = ARouterConstants.ACTIVITY_URL_GJC_QUERY_LIST)
class GjcQueryActivity :
    BaseBindingActivity<ActivityGjcQueryBinding, GjcQueryViewModel>() {

    override fun layoutId() = R.layout.activity_gjc_query

    override fun viewModelClass() = GjcQueryViewModel::class.java

    override fun initOnCreate(savedInstanceState: Bundle?) {
        setBackArrow("国际出港查询")

        binding.viewModel = viewModel

        // 绑定分页逻辑
        viewModel.pageModel
            .bindSmartRefreshLayout(binding.srl, binding.rv, viewModel, getLifecycleOwner())

        // 监听刷新事件
        FlowBus.with<String>(ConstantEvent.EVENT_REFRESH).observe(this) {
            viewModel.refresh()
        }

        // 初始化代理列表
        viewModel.initAgentList()

        // 初始加载
        viewModel.refresh()
    }

    companion object {
        @JvmStatic
        fun start(context: Context) {
            val starter = Intent(context, GjcQueryActivity::class.java)
            context.startActivity(starter)
        }
    }
}
